*adjust the PALMS data with MW's income variables for final release
*keep old income data in a separate file in case users want to try and replicate MW's work.
*A Kerr, July 2013
*revised November 2015
*revised May 2016
*revised Aug 2019


local palmsmergefolder="C:\Users\01430870\Desktop\Andy\DataFirst\main project\PALMS"

cd "`palmsmergefolder'"

set more off
cap log close





use "`palmsmergefolder'\palmsv3.3tempc.dta",  clear
numlabel, add force

drop earnperiod earnperiod_wage earnperiod_self jobsalary jobsalcat wageempincome wageempincome2 empsalcat1 empsalcat2 empsalcat3 selfempincome1 selfempincome2 ///
imputed salary_impute impute_gross emp_impute deduc1 deducamt1 selfempinccat1 selfempinccat2 selfempinccat3 selfempinccat4 selfempexpgoods selfempexprenum ///
selfempexpoth selfempexpall tipscomm jobsalperiod2 monthlyjobsalary salaryrefusedontknow selfemppayperiod2 monthlyjobearn earningsrefusedontknow earningscat ///
wage_earnings selfempinc expenses selfempincnet wageinfo selfinfo earningsinfo /*inc_outlier*/ outlier bracket bracketperiod highsalary highresid Randinfo ///
pslsd_realearnings pslsd_earnings pslsd_employerAll

*October 2018, merge back some data dropped at the start of PALMSwages work. It was dropped to make code run faster. 
merge 1:1 wave uqnr personnr using "`palmsmergefolder'\palmsv3.3forfinalmerge.dta"
drop _merge

*October 2018, getting rid of ceweight2 so people don't continue using. 
*drop ceweight2

rename outlier2 outlier

label var earnings "consistent monthly earnings (rand amt) variable for PALMSv2+"
label var realearnings "consistent REAL monthly earnings (rand amt) variable for PALMSv2+"
label var outlier "outlier flag based on regression+showing a studentised residual >=5"



*************************Add in 3 digit industry and 4 digit occupation codes****************************
*and separate occupation into two variables, mostly the same but some diffs bet OHS96- LFS 2002:2 and then later LFS and QLFSs. 
*December 2018 for PALMSv3.3

do "C:\Users\01430870\Desktop\Andy\DataFirst\main project\Industry and Occupation codes\QLFS and OHS 96-98 industry codes.do"
label values industry2  industry2 
do "C:\Users\01430870\Desktop\Andy\DataFirst\main project\Industry and Occupation codes\LFS and OHS 99 industry labels.do"
label values industry industry 

gen occupation2=occupation if  wave>=13 & wave<.
replace occupation=. if occupation2!=.
label var occupation "4 digit occ code OHS 96-LFS 2002:1"
label var occupation2 "4 digit occ code LFS 2002:2 onwards"


/* March 19, leaving this for next PALMS release since unclear what occupation codes are what. Amy Thorton has different idea of whats going on to AK!
do "C:\Users\01430870\Desktop\Andy\DataFirst\main project\Industry and Occupation codes\QLFS occupation codes.do"
label values occupation2 occupation2

*hard to label occupation for OHS and LFS in the way the codelists are set out!! FInally did it but not using until I do more checks on how occup codes in OHS and LFS 2000-2002 are similar.
*Amy thinks there are the same codes 2001-2015 but I remember some issues ( main one is some OHS/LFS occups not labelled at all using QLFS occup code list).
do "C:\Users\01430870\Desktop\Andy\DataFirst\main project\Industry and Occupation codes\LFS 2000 occupation codes.do"
label values occupation occupation
*/




**********now do domestic worker occupation and industry  corrections to OHS 94 and employer corrections to OHS 94, 95 and 96. *******
***********May 2017 using code from Jacqueline Mosomi, UCT PhD student, now postdoc at SALDRU.*********
gen educcat=.
replace educcat=1 if yrseduc==0
replace educcat=2 if yrseduc>0 & yrseduc<8
replace educcat=3 if yrseduc>=8 & yrseduc<12
replace educcat=4 if yrseduc==12
replace educcat=5 if yrseduc>12 & yrseduc<18

label define educcat 1"None" 2"Some_primary" 3"Incomplete_secondary" 4"complete_secondary" 5"Some_tertiary/degree"
label values educcat educcat

recode jobindcode (11/max=.) (1=1 "agric")(2= 2 "mining")(3 = 3 "manuf") (4=4 "utilities") ///
(5= 5 "construct")(6 = 6 "trade")(7=7 "transport")(8= 8 "finance")(9 = 9 "services") (10=10 "Domestic"), gen(sector) 
label values sector sector


recode jobocccode (11/max=.) (1=1 "managers")(2= 2 "profess")(3 = 3 "tech") (4=4 "clerks") ///
(5= 5 "service")(6 = 6 "agric")(7=7 "craft")(8= 8 "operators")(9 = 9 "element") (10=10 "DW"), gen(occup) 
label values occup occup


gen DW=.
replace DW=1 if jobocccode==10
replace DW=0 if jobocccode>=1 & jobocccode<=9
label define DW 1"yes" 0"no" 
label values DW DW

gen domestic=.
replace domestic=1 if jobindcode==10
replace domestic=0 if jobindcode>=1 & jobindcode<=9
label define domestic 1"yes" 0"no" 
label values domestic domestic

*for the imputation in 94 PSLSD 93 and OHS 95 are used. PSLSD occup is set to 10 (dom work) if industry ==10 but just for the imputation.
replace occup=10 if wave==0 & sector==10 &empstat1==1 & employerAll==0

*now do the imputation for OHS 94 occupation:
probit DW i.urbrur i.educcat i.province i.gender  c.age##c.age if ( wave==2| wave==0) & (occup==10 | occup==9) [pw=ceweight1]
predict pi_hat if wave==1 & (occup==10 | occup==9) 
set seed 90456
gen r = uniform() if wave ==1 & (occup==10 | occup==9)
replace occup=10 if wave==1 &(occup==9|DW==1) & r<=pi_hat 

drop r

*now do the imputation for OHS 94 sector:
probit domestic i.urbrur i.educcat i.province i.gender  c.age##c.age if ( wave==2| wave==0) & (sector==10 | sector==9)  [pw=ceweight1]

predict pi_hat1 if wave==1 & (sector==10 | sector==9)

set seed 4689
gen r = uniform() if wave ==1 & (sector==10 | sector==9)
replace sector=10 if wave==1 & (sector==9|domestic==1) & r<=pi_hat1 

*now change jobindcode and jobocccode
replace jobindcode=10 if sector==10 & wave==1
replace jobocccode=10 if occup==10 & wave==1


label var uif "Does employer deducted unemployment insurance fund contributions?"

******************************************************************************************************************
                      *classifying all domestic workers as wage employees*
*******************************************************************************************************************					  
replace employerAll=0 if occup==10  & empstat1==1
replace employerAll=0 if sector==10 & empstat1==1


drop educcat DW domestic  sector occup pi_hat pi_hat1 r

*************************************the end of the domestic worker fixes for OHS 94-96.***************************


********************************now create an employment variable that excludes SEAWs******************************
gen employedpreferred=1 if empstat1==1
replace employedpreferred=. if employerAll==1 & jobindcode==1
label var employedpreferred "=1 if employed and NOT a self-employed agricultural worker"


/*aug 2029, cutting this out for now, still issues, trying to resolve
*******************************October 2018, adding in census location data**********************************
**************************this save needed so I can use it to merge in census location data*****************
save "`palmsmergefolder'\palmsv3.3for_location.dta", replace

merge 1:1 uqnr personnr wave using "C:\Users\01430870\Desktop\Andy\DataFirst\main project\Census 2001 and 2011 location work\palms3.3withcensus2001.dta"
gen location_census2001=1 if _merge==3
replace location_census2001=0 if sp_code2001==. & (wave==16 | wave==17 | wave==18 | (wave>=23 & wave<=50))
label var location_census2001 "=1 if 2001 location data matched,=0 if not matched, =. if all wave not matched"

drop _merge

merge 1:1 uqnr personnr wave using "C:\Users\01430870\Desktop\Andy\DataFirst\main project\Census 2001 and 2011 location work\palms3.3withcensus2011.dta"
gen location_census2011=1 if _merge==3
replace location_census2011=0 if sp_code2011==. & wave>=51 & wave<.
label var location_census2011 "=1 if 2011 location data matched,=0 if not matched,=. if all wave not matched"
tab location_census2011

drop _merge

*************************************the end of the location data merging in***************************
*/
*put in new numlabels.
numlabel, add force
;
 order uqnr-wave ea stratum province pweight ceweight1 hweight urbrur popgroup- occupation1 occupation2 jobunion- employedpreferred

datasignature set, reset

save "`palmsmergefolder'\palmsv3.3.dta", replace


*do this again and KEEP all the extra income variables in another file:

use "`palmsmergefolder'\palmsv3.3tempc.dta",  clear

keep uqnr personnr wave earnperiod earnperiod_wage earnperiod_self jobsalary jobsalcat wageempincome wageempincome2 empsalcat1 empsalcat2 empsalcat3 selfempincome1 selfempincome2 ///
imputed salary_impute impute_gross emp_impute deduc1 deducamt1 selfempinccat1 selfempinccat2 selfempinccat3 selfempinccat4 selfempexpgoods selfempexprenum ///
selfempexpoth selfempexpall tipscomm jobsalperiod2 monthlyjobsalary salaryrefusedontknow selfemppayperiod2 monthlyjobearn earningsrefusedontknow earningscat ///
/*wage_earnings selfempinc expenses selfempincnet wageinfo selfinfo earningsinfo /*inc_outlier*/ highresid Randinfo*/ pslsd_earnings

notes drop _dta

note: PALMSv3.3 income data, created by A Kerr, M Wittenberg & D Lam, August 2019

datasignature set, reset

save "`palmsmergefolder'\palmsv3.3incomes.dta", replace


