



*Putting the QLFS together with the OHS and LFS data. 
*Jan 2013,
*revised October 2015
* revised April 2016
*and again May 2017
*and again April 2018, and Oct 2018
*A Kerr, DataFirst

clear all
set more off


local ohslfsmergefolder="C:\Users\01430870\Desktop\Andy\DataFirst\main project\OHSlfs"
local qlfsmergefolder="C:\Users\01430870\Desktop\Andy\DataFirst\main project\Quarterly LFS\QLFSmerge"
local palmsmergefolder="C:\Users\01430870\Desktop\Andy\DataFirst\main project\PALMS"
local pslsdmergefolder="C:\Users\01430870\Desktop\Andy\DataFirst\main project\PSLSD\pslsdmerge"
local ceweightsfolder="C:\Users\01430870\Desktop\Andy\DataFirst\main project\From Takwanisa"



use "`ohslfsmergefolder'\ohslfsdatav6.dta"
 /*june 2013: no longer neccessary: tostring uqnr, replace format (%20.0f)
 drop personid*/

 *must fix up inperson to be consistent with qlfs
 replace inperson=8 if inperson==. &wave>6 &age<15
 replace inperson=9 if inperson==. &wave>6 &age>15 &age<.
 label drop inperson
 label define inperson 1"Yes" 2"No" 8"Not Applicable" 9"Unspecified"
 
 *adding in a don't know option which was introduced in QLFSs
 label drop educhigh
 label var educhigh "Highest level of education"
label define educhigh 0 "No schooling" 1 "Grade 0" 2 "Grade 1"  3 "Grade 2" 4 "Grade 3" 5 "Grade 1/grade2/grade 3" 6 "Grade 4" 7 "Grade 5" 8"Grade 6" 9 "Grade 7" 10 "Grade 8" 11 "Grade 9" ///
	12 "Grade 10/NTC I"	13 "Grade 11/NTC II" 14 "Grade 12/NTC III" 15 "Certificate or diploma with less than grade 12" 16 "Certificate or diploma with grade 12" ///
	17 "Undergraduate degree" 18 "Post-graduate degree/diploma" 19 "Degree (undergrad or postgrad)" 20 "Other" 21 "Don't know"



 
label var numworkers "Number of regular workers at job, LFS"

gen writtencontract=.
replace writtencontract=1 if jobcontract== 1
replace writtencontract=0 if jobcontract== 2
label var writtencontract "=1 if employee has written contract, LFS+QLFS"
drop jobcontract*



*now add in the QLFS data 
append using "`qlfsmergefolder'\palmsconsistentqlfs.dta"

*June 2013, replacing the educhigh variable with a years of education variable.
recode educhigh (0 1 = 0) (2 = 1) (3 5 = 2) (4 = 3) (6 = 4) (7 = 5) (8 = 6) (9 = 7) (10 = 8) (11 = 9) (12 = 10) (13 = 11) (14 = 12) (15 = 11) (16 = 13) (17 19 = 15) (18 = 16) (20 21=.), gen(yrseduc)
label var yrseduc "Years of education, derived variable"

*April 2016, adding in data from QLFS into years of education variable (did this in PALMS v2 up until 2012 q1 only, new educ var since 2012:3).. 
gen yrseduc2= educhigh3 if educhigh3<=12
replace yrseduc2=10 if educhigh3==13
replace yrseduc2=11 if educhigh3==14
replace yrseduc2=12 if educhigh3==15
replace yrseduc2=13 if educhigh3==16
replace yrseduc2=14 if educhigh3==17
replace yrseduc2=15 if educhigh3==18
replace yrseduc2=11 if educhigh3==19
replace yrseduc2=13 if educhigh3==20
replace yrseduc2=13 if educhigh3==21
replace yrseduc2=14 if educhigh3==22
replace yrseduc2=15 if educhigh3==23
replace yrseduc2=17 if educhigh3==24
replace yrseduc2=15 if educhigh3==25
replace yrseduc2=16 if educhigh3==26
replace yrseduc2=16 if educhigh3==27
replace yrseduc2=17 if educhigh3==28
replace yrseduc2=0 if educhigh3==98

replace yrseduc=yrseduc2 if yrseduc==.
drop educhigh yrseduc2

*new in 2018, new educ variable since 2016:Q3...
gen yrseduc3=educhigh4 if educhigh4<=12
replace yrseduc3=12 if educhigh4==13
replace yrseduc3=10 if educhigh4==14
replace yrseduc3=11 if educhigh4==15
replace yrseduc3=12 if educhigh4==16
replace yrseduc3=13 if educhigh4==17
replace yrseduc3=14 if educhigh4==18
replace yrseduc3=15 if educhigh4==19
replace yrseduc3=11 if educhigh4==20
replace yrseduc3=13 if educhigh4==21
replace yrseduc3=13 if educhigh4==22
replace yrseduc3=14 if educhigh4==23
replace yrseduc3=15 if educhigh4==24
replace yrseduc3=17 if educhigh4==25
replace yrseduc3=15 if educhigh4==26
replace yrseduc3=16 if educhigh4==27
replace yrseduc3=16 if educhigh4==28
replace yrseduc3=17 if educhigh4==29
replace yrseduc3=0 if educhigh4==98

replace yrseduc=yrseduc3 if yrseduc==.
drop yrseduc3
********************Now add in PSLSD****************
append using "`pslsdmergefolder'\PSLSDforPALMS_adj.dta"


label var enrollment3 "Enrollment status: PSLSD, OHS and LFS only" 

label drop wave
label variable wave "Survey wave, PSLSD 1993=0, OHS 1994=1, QLFS Dec 2015=54"
label define wave 0"PSLSD 1993" 1"OHS 1994" 2"OHS 1995" 3"OHS 1996" 4"OHS 1997" 5"OHS 1998" 6"OHS 1999" 7"LFS 00:1" 8"LFS 00:2" 9"LFS 01:1" 10"LFS 01:2" 11"LFS 02:1" ///
	12"LFS 02:2" 13"LFS 03:1" 14"LFS 03:2" 15"LFS 04:1" 16"LFS 04:2" 17"LFS 05:1" 18"LFS 05:2" 19"LFS 06:1" 20"LFS 06:2" ///
	21"LFS 07:1" 22"LFS 07:2" 23 "QLFS 08:1" 24 "QLFS 08:2" 25 "QLFS 08:3" 26 "QLFS 08:4" 27 "QLFS 09:1" 28 "QLFS 09:2" 29 "QLFS 09:3" 30 "QLFS 09:4" ///
	31 "QLFS 2010:1" 32 "QLFS 2010:2" 33 "QLFS 2010:3" 34 "QLFS 2010:4" 35 "QLFS 2011:1" 36 "QLFS 2011:2" 37 "QLFS 2011:3" 38 "QLFS 2011:4" 39 "QLFS 2012:1" ///
	40 "QLFS 2012:2" 41 "QLFS 2012:3" 42 "QLFS 2012:4" 43 "QLFS 2013:1" 44 "QLFS 2013:2" 45 "QLFS 2013:3" 46 "QLFS 2013:4" 47 "QLFS 2014:1" 48 "QLFS 2014:2" ///
	49 "QLFS 2014:3" 50 "QLFS 2014:4"  51 "QLFS 2015:1" 52 "QLFS 2015:2" 53 "QLFS 2015:3" 54 "QLFS 2015:4"  55 "QLFS 2016:1" 56 "QLFS 2016:2" 57 "QLFS 2016:3" 58 "QLFS 2016:4" ///
	59 "QLFS 2017:1" 60 "QLFS 2017:2" 61 "QLFS 2017:3" 62 "QLFS 2017:4" 63 "QLFS 2018:1" 64 "QLFS 2018:2" 65 "QLFS 2018:3" 66 "QLFS 2018:4" 67 "QLFS 2019:1" 68 "QLFS 2019:2" 
label values wave wave


label var jobstartyear "Year started working for employer, LFS+QLFS only"
label var jobstartmonth "Month started working for employer, LFS+QLFS only"
*label var ceweight "Older Cross entropy weight, OHS+LFS only, ASSA 2003 model"
label var industry "3 digit industry SIC code, OHS 99+LFS"
label var occupation "4 digit occupation code, OHS 96 onwards"
label var jobunion " Member of trade union, PSLSD, OHS+LFS+QLFS 2012 onwards only"
label var publicemp "Dummy: Employed by govt/public enterprise, PSLSD,LFS+QLFS only"
label var regisvat "Business registered for VAT, all in LFS, only self-emp in QLFS"
label var pweight "Original Stats SA/PSLSD person weight"
label var urbrur "Area type, waves 0-15 (LFS 2004:1)"
label var urbrur2 "Area type, waves 23-50 (QLFS 2008:1- 2014:4)"

*some others that need slight updating now that the PSLSD is included:
 label var employer1 "Who does individual work for? (PSLSD+OHS only)"

 *numworkers 2 needs new label
 label define numworkers2 1"0 employees" 2"1 employee " 3"Between 2 and 4 employees" 4"Between 5 and 9 employees" 5"Between 10 and 19 employees" 6"Between 20 and 49 employees" 7"50 or more employees" 8"Do not know"  88"Not applicable" 
 label values numworkers2 numworkers2
 
 *so does businesstype3 (not working in the numlabel, add force command below, I am not sure why!?
 label define businesstype3  1" National/provincial/local government" 2"Government controlled business" 3" A private enterprise" 4"Non-profit organisation (NGO/CBO)" 5"A private household" 6"Do not know"
 label values businesstype3  businesstype3  
 
 *so does registax
 label define registax 0" Not applicable" 1"Yes" 2"No" 3"Do not know" 
  label values registax registax 
  
  
  
  
  *LFS formalreg needs a new name. 
  rename formalreg formalreg0
*label var earnperiodaddjob "Earnings Period for 2nd job, OHS only"
/*label drop jobsector
label define formalreg 1"Formal employment" 2"Informal Employment" 3"Don't Know" 7"Other" 8"Not Applicable" 9"Unspecified"
label values formalreg formalreg
variabel label formalreg "LFS and QLFS variable for wage/self/domestic: business is formal,registered"
*/

*adding in new public sector dummy that includes an estimate for OHSs using the industry codes

gen publicemp2=.
replace publicemp2= publicemp if publicemp !=.

replace publicemp2=1 if industry2 !=. & ((industry2 >=910 & industry2<932 ) |industry2==410 | industry2==411 | industry2==711) & publicemp2==.
replace publicemp2=0 if industry2 !=. & (industry2<910 | industry2>=932) & industry2!=999 & publicemp2==.
replace publicemp2=1 if industry!=. & ((industry >=910 & industry<932 ) | industry==410 | industry==411 | industry==711) & publicemp2==. &wave==6
replace publicemp2=0 if industry !=. & ((industry<910 | industry>=932) | industry==410 | industry==411 | industry==711) & industry!=999 & industry!=888 & industry!=8888 & publicemp2==. &wave==6

label var publicemp2 "Public employment dummy that includes OHS, as well as PSLSD,LFS+QLFS"

*adding in UIF deduction question, Aug 2019
replace uif=1 if jobuif==1
replace uif=2 if jobuif==2 | jobuif==3
replace uif=3 if jobuif==4

drop jobuif q48uif

/*not using these anymore, so cut
****************************Now add in new 2008 ASSA model derived cross entropy weights*********
sort wave uqnr personnr
merge 1:1 wave uqnr personnr using "`ceweightsfolder'\palmsceweightsv2.1.dta"

drop _merge

*October 2015, new CE weights 2012-2014
sort wave uqnr 
merge m:1 wave uqnr using "`ceweightsfolder'\qlfs2012_2-2014_4_ceweight\qlfs2012_2-2014_4_ceweight.dta", update
drop _merge
drop hhsize
*April 2016, add in 2015 CE weights
sort wave uqnr 
merge 1:1 wave uqnr personnr using "`ceweightsfolder'\2015 CE weights\ceweights2015.dta", update
tab _merge
drop _merge

*may 2017, add in 2016 ce weights

sort wave uqnr 
merge m:1 wave uqnr  using "`ceweightsfolder'\ceweights2016.dta", update
tab _merge
drop _merge

*sept 2017, add in the 2017 CE weights.
merge m:1 wave uqnr using "`ceweightsfolder'\ceweights2017q1q2.dta", update
tab _merge
drop _merge



*Add in PSLSD cewights
sort wave uqnr 
merge 1:1 wave uqnr personnr using "`pslsdmergefolder'\PSLSDceweights.dta", update

tab _merge
drop _merge
*/
***********************************NOW ADDING IN THE 2019 CE WEIGHTS BASED ON THE STATS SA 2018 MID YEAR POPULATION ESTIMATES.****************
********************************************WEIGHTS COME FROM TAKWANISA MACHEMEDZE AT DATAFIRST***********************************************
*To get new ceweights, send this file to TM: keep uqnr personnr year wave province pweight popgroup gender age

merge m:1 wave uqnr using "`ceweightsfolder'\palms_v3_3_wgtd.dta"
*drop ce_wgt_assa08
rename ceweight_2019 ceweight1

drop _merge

*October 2018, I decided it was better to have only one ceweight otherwise people will be confused, and the ASSA 2008 model is too out of date now to be useful. 
*Mortality was too high, fertility too low.
*drop ceweight2


**************************************************************************************************

*October 2015, creating a stratum variable based on stratum in each wave and the wave itself.
egen stratum2=group (stratum wave)
label var stratum2 "stratum var to be used for svyset in Stata- group of stratum and wave"
drop stratum
rename stratum2 stratum



compress

order uqnr /*uqnr_orig*/ personnr year wave province metro stratum urbrur urbrur2 urbrur3  ea dc ceweight1 /*ceweight2*/ pweight hweight inperson popgroup gender age marstat  yrseduc educhigh0 educhigh1 educhigh2 educhigh3 educhigh4 enrolled enrollment3 empstat1 empstat2 ///
employer employer1 employer2 numworkers numworkers2 jobstartyear jobstartmonth writtencontract selfformalreg selfvatreg selfpaidemp selfunpaidemp wageformalreg formalreg0 formalreg1 informal_emp_derived informal_sector_derived /// 
regisvat /*registax*/ jobindcode industry industry2 indust2digit jobocccode occupation occupation1 jobunion publicemp ///
businesstype1 businesstype2 businesstype3 hrslstwk earnperiod earnperiod_wage earnperiod_self jobsalary jobsalcat wageempincome wageempincome2 empsalcat1 empsalcat2 empsalcat3 selfempincome1 ///
selfempincome2 imputed salary_impute impute_gross emp_impute deduc1 deducamt1 selfempinccat1 selfempinccat2 selfempinccat3 selfempinccat4 selfempexpgoods selfempexprenum selfempexpoth ///
selfempexpall tipscomm jobsalperiod2 monthlyjobsalary salaryrefusedontknow selfemppayperiod2 monthlyjobearn earningsrefusedontknow earningscat jobcontract2 uif
	

label data "PALMS: PSLSD 1993, OHS 1994-1999, LFS Feb 2000-Sept 07, QLFS Mar 2008-June 2019"

notes
notes drop _dta


numlabel, add force
*changed the data set name below from palmsvX because final PALMS dataset is called palmsvX!

save "`palmsmergefolder'\palmsv3.3nowageadj.dta", replace

*I'm also going to have to do some label adjusting, eg note that occuption codes are only for OHS 96 onwards. Maybe I don't have to specify in the data though as long as I do it in variable list?
;
*creating a small file for TM to do new ceweights for everyone using the new stats sa model
local palmsmergefolder="C:\Users\01430870\Desktop\Andy\DataFirst\main project\PALMS"
keep uqnr wave popgroup gender age province pweight personnr
save "`palmsmergefolder'\palmsv3.3fornewceweights.dta", replace

