* qlfsappend.do
* Append all waves of South Africa Q Labour Force Survey
* Andrew Kerr, Aug 2014, Based on a do file by D Lam, University of Michigan
*October 2015: its working until 2014_4 inclusive, and with income data from LMD.
* April 2015, adjusted to incl 2015:4
*October 2018, adjusted several times before this also. 
*adjusted Aug 2019

clear all

set more off

global mergefolder="C:\Users\01430870\Desktop\Andy\DataFirst\main project\Quarterly LFS\QLFSmerge"

/***********************************************************************/
*re-run files that do renaming for each year:

forval y=2008/2018 {
	forval i=1/4 {
		do "$mergefolder\qlfsmerge`y'_`i'.do"
	}
}

forval y=2019/2019 {
	forval i=1/2 {
		do "$mergefolder\qlfsmerge`y'_`i'.do"
	}
}
***************************************************************************/

cap clear

set more off
use "$mergefolder\qlfs2008_1.dta"
gen int year=2008
gen byte round=1
append using "$mergefolder\qlfs2008_2.dta"
replace year=2008 if year==.
replace round=2 if round==.

append using "$mergefolder\qlfs2008_3.dta"
replace year=2008 if year==.
replace round=3 if round==.

append using "$mergefolder\qlfs2008_4.dta"
replace year=2008 if year==.
replace round=4 if round==.

forval y=2009/2018 {
	forval i=1/4 {
		qui append using "$mergefolder\qlfs`y'_`i'.dta"
		qui replace year=`y' if year==.
		qui replace round=`i' if round==.
		tab wave
	}
}
	
/*now incorp above
*first quarter of 2019
*/
append using "$mergefolder\qlfs2019_1.dta"
replace year=2019 if year==.
replace round=1 if round==.

append using "$mergefolder\qlfs2019_2.dta"
replace year=2019 if year==.
replace round=2 if round==.

	

compress

tab wave
tab year round

*gen uqnr


order wave uqnr personnr gender age 
sort wave uqnr personnr
save "$mergefolder\qlfswaves23to68.dta", replace
/*
keep WhyNotWork
WhyNotWork2
WillAcceptWork
*/
